/**
 * <copyright>
 * </copyright>
 *
 * $Id: COBOLPackageImpl.java,v 1.3 2004/11/22 23:56:42 akkina Exp $
 */
package com.ibm.etools.cobol.impl;

import com.ibm.etools.cobol.COBOL66Element;
import com.ibm.etools.cobol.COBOL88Element;
import com.ibm.etools.cobol.COBOL88ElementValue;
import com.ibm.etools.cobol.COBOLAddressingType;
import com.ibm.etools.cobol.COBOLAlphaNumericEditedType;
import com.ibm.etools.cobol.COBOLAlphaNumericType;
import com.ibm.etools.cobol.COBOLAlphabeticType;
import com.ibm.etools.cobol.COBOLClassifier;
import com.ibm.etools.cobol.COBOLComposedType;
import com.ibm.etools.cobol.COBOLDBCSType;
import com.ibm.etools.cobol.COBOLElement;
import com.ibm.etools.cobol.COBOLElementInitialValue;
import com.ibm.etools.cobol.COBOLExternalFloatType;
import com.ibm.etools.cobol.COBOLFactory;
import com.ibm.etools.cobol.COBOLFixedLengthArray;
import com.ibm.etools.cobol.COBOLInitialValueKind;
import com.ibm.etools.cobol.COBOLInternalFloatType;
import com.ibm.etools.cobol.COBOLNumericEditedType;
import com.ibm.etools.cobol.COBOLNumericType;
import com.ibm.etools.cobol.COBOLNumprocValue;
import com.ibm.etools.cobol.COBOLObjectReferenceType;
import com.ibm.etools.cobol.COBOLPackage;
import com.ibm.etools.cobol.COBOLRedefiningElement;
import com.ibm.etools.cobol.COBOLSimpleType;
import com.ibm.etools.cobol.COBOLSourceText;
import com.ibm.etools.cobol.COBOLTruncValue;
import com.ibm.etools.cobol.COBOLUnicodeType;
import com.ibm.etools.cobol.COBOLUsageValues;
import com.ibm.etools.cobol.COBOLVariableLengthArray;

import com.ibm.etools.tdlang.TDLangPackage;

import com.ibm.etools.tdlang.impl.TDLangPackageImpl;

import com.ibm.etools.typedescriptor.TypeDescriptorPackage;

import com.ibm.etools.typedescriptor.impl.TypeDescriptorPackageImpl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class COBOLPackageImpl extends EPackageImpl implements COBOLPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolSimpleTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolVariableLengthArrayEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolRedefiningElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolComposedTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass coboL88ElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass coboL88ElementValueEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolAlphaNumericTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolNumericEditedTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolNumericTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass coboL66ElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolFixedLengthArrayEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass coboldbcsTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolAlphaNumericEditedTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolClassifierEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolAlphabeticTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolObjectReferenceTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolSourceTextEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolUnicodeTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolInternalFloatTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolExternalFloatTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolAddressingTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cobolElementInitialValueEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum cobolUsageValuesEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum cobolInitialValueKindEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum cobolTruncValueEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum cobolNumprocValueEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see com.ibm.etools.cobol.COBOLPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private COBOLPackageImpl() {
		super(eNS_URI, COBOLFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static COBOLPackage init() {
		if (isInited) return (COBOLPackage)EPackage.Registry.INSTANCE.get(COBOLPackage.eNS_URI);

		// Obtain or create and register package
		COBOLPackageImpl theCOBOLPackage = (COBOLPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof COBOLPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new COBOLPackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		TypeDescriptorPackageImpl theTypeDescriptorPackage = (TypeDescriptorPackageImpl)(EPackage.Registry.INSTANCE.get(TypeDescriptorPackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(TypeDescriptorPackage.eNS_URI) : TypeDescriptorPackageImpl.eINSTANCE);
		TDLangPackageImpl theTDLangPackage = (TDLangPackageImpl)(EPackage.Registry.INSTANCE.get(TDLangPackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(TDLangPackage.eNS_URI) : TDLangPackageImpl.eINSTANCE);

		// Create package meta-data objects
		theCOBOLPackage.createPackageContents();
		theTypeDescriptorPackage.createPackageContents();
		theTDLangPackage.createPackageContents();

		// Initialize created meta-data
		theCOBOLPackage.initializePackageContents();
		theTypeDescriptorPackage.initializePackageContents();
		theTDLangPackage.initializePackageContents();

		return theCOBOLPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLSimpleType() {
		return cobolSimpleTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLSimpleType_Usage() {
		return (EAttribute)cobolSimpleTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLSimpleType_PictureString() {
		return (EAttribute)cobolSimpleTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLSimpleType_Synchronized() {
		return (EAttribute)cobolSimpleTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLElement() {
		return cobolElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLElement_Level() {
		return (EAttribute)cobolElementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLElement_Redefined() {
		return (EAttribute)cobolElementEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLElement_IsFiller() {
		return (EAttribute)cobolElementEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLElement_IsExternal() {
		return (EAttribute)cobolElementEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLElement_IsGlobal() {
		return (EAttribute)cobolElementEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCOBOLElement_Contains() {
		return (EReference)cobolElementEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCOBOLElement_SharedType() {
		return (EReference)cobolElementEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCOBOLElement_Array() {
		return (EReference)cobolElementEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCOBOLElement_Group() {
		return (EReference)cobolElementEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCOBOLElement_Source() {
		return (EReference)cobolElementEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCOBOLElement_Initial() {
		return (EReference)cobolElementEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLVariableLengthArray() {
		return cobolVariableLengthArrayEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLVariableLengthArray_MinUpper() {
		return (EAttribute)cobolVariableLengthArrayEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCOBOLVariableLengthArray_DependingOn() {
		return (EReference)cobolVariableLengthArrayEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLRedefiningElement() {
		return cobolRedefiningElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCOBOLRedefiningElement_Redefines() {
		return (EReference)cobolRedefiningElementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLComposedType() {
		return cobolComposedTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCOBOLComposedType_Element() {
		return (EReference)cobolComposedTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOL88Element() {
		return coboL88ElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOL88Element_Name() {
		return (EAttribute)coboL88ElementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCOBOL88Element_Has() {
		return (EReference)coboL88ElementEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOL88ElementValue() {
		return coboL88ElementValueEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOL88ElementValue_LowerLimit() {
		return (EAttribute)coboL88ElementValueEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOL88ElementValue_UpperLimit() {
		return (EAttribute)coboL88ElementValueEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOL88ElementValue_Range() {
		return (EAttribute)coboL88ElementValueEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLAlphaNumericType() {
		return cobolAlphaNumericTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLAlphaNumericType_JustifyRight() {
		return (EAttribute)cobolAlphaNumericTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLNumericEditedType() {
		return cobolNumericEditedTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLNumericEditedType_BlankWhenZero() {
		return (EAttribute)cobolNumericEditedTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLNumericEditedType_CurrencySymbol() {
		return (EAttribute)cobolNumericEditedTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLNumericEditedType_CurrencySign() {
		return (EAttribute)cobolNumericEditedTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLNumericEditedType_Decimal() {
		return (EAttribute)cobolNumericEditedTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLNumericType() {
		return cobolNumericTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLNumericType_Signed() {
		return (EAttribute)cobolNumericTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLNumericType_SignLeading() {
		return (EAttribute)cobolNumericTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLNumericType_SignSeparate() {
		return (EAttribute)cobolNumericTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLNumericType_Trunc() {
		return (EAttribute)cobolNumericTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLNumericType_Numproc() {
		return (EAttribute)cobolNumericTypeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLNumericType_Precision() {
		return (EAttribute)cobolNumericTypeEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLNumericType_Scale() {
		return (EAttribute)cobolNumericTypeEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOL66Element() {
		return coboL66ElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOL66Element_Name() {
		return (EAttribute)coboL66ElementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCOBOL66Element_Start() {
		return (EReference)coboL66ElementEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCOBOL66Element_EndOf() {
		return (EReference)coboL66ElementEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLFixedLengthArray() {
		return cobolFixedLengthArrayEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLFixedLengthArray_MaxUpper() {
		return (EAttribute)cobolFixedLengthArrayEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLDBCSType() {
		return coboldbcsTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLDBCSType_JustifyRight() {
		return (EAttribute)coboldbcsTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLAlphaNumericEditedType() {
		return cobolAlphaNumericEditedTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLClassifier() {
		return cobolClassifierEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLClassifier_Typedef() {
		return (EAttribute)cobolClassifierEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCOBOLClassifier_TypedElement() {
		return (EReference)cobolClassifierEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLAlphabeticType() {
		return cobolAlphabeticTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLAlphabeticType_JustifyRight() {
		return (EAttribute)cobolAlphabeticTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLObjectReferenceType() {
		return cobolObjectReferenceTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLObjectReferenceType_ClassName() {
		return (EAttribute)cobolObjectReferenceTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLSourceText() {
		return cobolSourceTextEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLSourceText_Source() {
		return (EAttribute)cobolSourceTextEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLSourceText_FileName() {
		return (EAttribute)cobolSourceTextEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLUnicodeType() {
		return cobolUnicodeTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLInternalFloatType() {
		return cobolInternalFloatTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLExternalFloatType() {
		return cobolExternalFloatTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLAddressingType() {
		return cobolAddressingTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCOBOLElementInitialValue() {
		return cobolElementInitialValueEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLElementInitialValue_InitVal() {
		return (EAttribute)cobolElementInitialValueEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCOBOLElementInitialValue_ValueKind() {
		return (EAttribute)cobolElementInitialValueEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getCOBOLUsageValues() {
		return cobolUsageValuesEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getCOBOLInitialValueKind() {
		return cobolInitialValueKindEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getCOBOLTruncValue() {
		return cobolTruncValueEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getCOBOLNumprocValue() {
		return cobolNumprocValueEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLFactory getCOBOLFactory() {
		return (COBOLFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		cobolSimpleTypeEClass = createEClass(COBOL_SIMPLE_TYPE);
		createEAttribute(cobolSimpleTypeEClass, COBOL_SIMPLE_TYPE__USAGE);
		createEAttribute(cobolSimpleTypeEClass, COBOL_SIMPLE_TYPE__PICTURE_STRING);
		createEAttribute(cobolSimpleTypeEClass, COBOL_SIMPLE_TYPE__SYNCHRONIZED);

		cobolElementEClass = createEClass(COBOL_ELEMENT);
		createEAttribute(cobolElementEClass, COBOL_ELEMENT__LEVEL);
		createEAttribute(cobolElementEClass, COBOL_ELEMENT__REDEFINED);
		createEAttribute(cobolElementEClass, COBOL_ELEMENT__IS_FILLER);
		createEAttribute(cobolElementEClass, COBOL_ELEMENT__IS_EXTERNAL);
		createEAttribute(cobolElementEClass, COBOL_ELEMENT__IS_GLOBAL);
		createEReference(cobolElementEClass, COBOL_ELEMENT__CONTAINS);
		createEReference(cobolElementEClass, COBOL_ELEMENT__SHARED_TYPE);
		createEReference(cobolElementEClass, COBOL_ELEMENT__ARRAY);
		createEReference(cobolElementEClass, COBOL_ELEMENT__GROUP);
		createEReference(cobolElementEClass, COBOL_ELEMENT__SOURCE);
		createEReference(cobolElementEClass, COBOL_ELEMENT__INITIAL);

		cobolVariableLengthArrayEClass = createEClass(COBOL_VARIABLE_LENGTH_ARRAY);
		createEAttribute(cobolVariableLengthArrayEClass, COBOL_VARIABLE_LENGTH_ARRAY__MIN_UPPER);
		createEReference(cobolVariableLengthArrayEClass, COBOL_VARIABLE_LENGTH_ARRAY__DEPENDING_ON);

		cobolRedefiningElementEClass = createEClass(COBOL_REDEFINING_ELEMENT);
		createEReference(cobolRedefiningElementEClass, COBOL_REDEFINING_ELEMENT__REDEFINES);

		cobolComposedTypeEClass = createEClass(COBOL_COMPOSED_TYPE);
		createEReference(cobolComposedTypeEClass, COBOL_COMPOSED_TYPE__ELEMENT);

		coboL88ElementEClass = createEClass(COBOL_88_ELEMENT);
		createEAttribute(coboL88ElementEClass, COBOL_88_ELEMENT__NAME);
		createEReference(coboL88ElementEClass, COBOL_88_ELEMENT__HAS);

		coboL88ElementValueEClass = createEClass(COBOL_88_ELEMENT_VALUE);
		createEAttribute(coboL88ElementValueEClass, COBOL_88_ELEMENT_VALUE__LOWER_LIMIT);
		createEAttribute(coboL88ElementValueEClass, COBOL_88_ELEMENT_VALUE__UPPER_LIMIT);
		createEAttribute(coboL88ElementValueEClass, COBOL_88_ELEMENT_VALUE__RANGE);

		cobolAlphaNumericTypeEClass = createEClass(COBOL_ALPHA_NUMERIC_TYPE);
		createEAttribute(cobolAlphaNumericTypeEClass, COBOL_ALPHA_NUMERIC_TYPE__JUSTIFY_RIGHT);

		cobolNumericEditedTypeEClass = createEClass(COBOL_NUMERIC_EDITED_TYPE);
		createEAttribute(cobolNumericEditedTypeEClass, COBOL_NUMERIC_EDITED_TYPE__BLANK_WHEN_ZERO);
		createEAttribute(cobolNumericEditedTypeEClass, COBOL_NUMERIC_EDITED_TYPE__CURRENCY_SYMBOL);
		createEAttribute(cobolNumericEditedTypeEClass, COBOL_NUMERIC_EDITED_TYPE__CURRENCY_SIGN);
		createEAttribute(cobolNumericEditedTypeEClass, COBOL_NUMERIC_EDITED_TYPE__DECIMAL);

		cobolNumericTypeEClass = createEClass(COBOL_NUMERIC_TYPE);
		createEAttribute(cobolNumericTypeEClass, COBOL_NUMERIC_TYPE__SIGNED);
		createEAttribute(cobolNumericTypeEClass, COBOL_NUMERIC_TYPE__SIGN_LEADING);
		createEAttribute(cobolNumericTypeEClass, COBOL_NUMERIC_TYPE__SIGN_SEPARATE);
		createEAttribute(cobolNumericTypeEClass, COBOL_NUMERIC_TYPE__TRUNC);
		createEAttribute(cobolNumericTypeEClass, COBOL_NUMERIC_TYPE__NUMPROC);
		createEAttribute(cobolNumericTypeEClass, COBOL_NUMERIC_TYPE__PRECISION);
		createEAttribute(cobolNumericTypeEClass, COBOL_NUMERIC_TYPE__SCALE);

		coboL66ElementEClass = createEClass(COBOL_66_ELEMENT);
		createEAttribute(coboL66ElementEClass, COBOL_66_ELEMENT__NAME);
		createEReference(coboL66ElementEClass, COBOL_66_ELEMENT__START);
		createEReference(coboL66ElementEClass, COBOL_66_ELEMENT__END_OF);

		cobolFixedLengthArrayEClass = createEClass(COBOL_FIXED_LENGTH_ARRAY);
		createEAttribute(cobolFixedLengthArrayEClass, COBOL_FIXED_LENGTH_ARRAY__MAX_UPPER);

		coboldbcsTypeEClass = createEClass(COBOL_DBCS_TYPE);
		createEAttribute(coboldbcsTypeEClass, COBOL_DBCS_TYPE__JUSTIFY_RIGHT);

		cobolAlphaNumericEditedTypeEClass = createEClass(COBOL_ALPHA_NUMERIC_EDITED_TYPE);

		cobolClassifierEClass = createEClass(COBOL_CLASSIFIER);
		createEAttribute(cobolClassifierEClass, COBOL_CLASSIFIER__TYPEDEF);
		createEReference(cobolClassifierEClass, COBOL_CLASSIFIER__TYPED_ELEMENT);

		cobolAlphabeticTypeEClass = createEClass(COBOL_ALPHABETIC_TYPE);
		createEAttribute(cobolAlphabeticTypeEClass, COBOL_ALPHABETIC_TYPE__JUSTIFY_RIGHT);

		cobolObjectReferenceTypeEClass = createEClass(COBOL_OBJECT_REFERENCE_TYPE);
		createEAttribute(cobolObjectReferenceTypeEClass, COBOL_OBJECT_REFERENCE_TYPE__CLASS_NAME);

		cobolSourceTextEClass = createEClass(COBOL_SOURCE_TEXT);
		createEAttribute(cobolSourceTextEClass, COBOL_SOURCE_TEXT__SOURCE);
		createEAttribute(cobolSourceTextEClass, COBOL_SOURCE_TEXT__FILE_NAME);

		cobolUnicodeTypeEClass = createEClass(COBOL_UNICODE_TYPE);

		cobolInternalFloatTypeEClass = createEClass(COBOL_INTERNAL_FLOAT_TYPE);

		cobolExternalFloatTypeEClass = createEClass(COBOL_EXTERNAL_FLOAT_TYPE);

		cobolAddressingTypeEClass = createEClass(COBOL_ADDRESSING_TYPE);

		cobolElementInitialValueEClass = createEClass(COBOL_ELEMENT_INITIAL_VALUE);
		createEAttribute(cobolElementInitialValueEClass, COBOL_ELEMENT_INITIAL_VALUE__INIT_VAL);
		createEAttribute(cobolElementInitialValueEClass, COBOL_ELEMENT_INITIAL_VALUE__VALUE_KIND);

		// Create enums
		cobolUsageValuesEEnum = createEEnum(COBOL_USAGE_VALUES);
		cobolInitialValueKindEEnum = createEEnum(COBOL_INITIAL_VALUE_KIND);
		cobolTruncValueEEnum = createEEnum(COBOL_TRUNC_VALUE);
		cobolNumprocValueEEnum = createEEnum(COBOL_NUMPROC_VALUE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		TDLangPackageImpl theTDLangPackage = (TDLangPackageImpl)EPackage.Registry.INSTANCE.getEPackage(TDLangPackage.eNS_URI);

		// Add supertypes to classes
		cobolSimpleTypeEClass.getESuperTypes().add(this.getCOBOLClassifier());
		cobolElementEClass.getESuperTypes().add(theTDLangPackage.getTDLangElement());
		cobolVariableLengthArrayEClass.getESuperTypes().add(this.getCOBOLFixedLengthArray());
		cobolRedefiningElementEClass.getESuperTypes().add(this.getCOBOLElement());
		cobolComposedTypeEClass.getESuperTypes().add(this.getCOBOLClassifier());
		cobolComposedTypeEClass.getESuperTypes().add(theTDLangPackage.getTDLangComposedType());
		cobolAlphaNumericTypeEClass.getESuperTypes().add(this.getCOBOLSimpleType());
		cobolNumericEditedTypeEClass.getESuperTypes().add(this.getCOBOLSimpleType());
		cobolNumericTypeEClass.getESuperTypes().add(this.getCOBOLSimpleType());
		coboldbcsTypeEClass.getESuperTypes().add(this.getCOBOLSimpleType());
		cobolAlphaNumericEditedTypeEClass.getESuperTypes().add(this.getCOBOLSimpleType());
		cobolClassifierEClass.getESuperTypes().add(theTDLangPackage.getTDLangClassifier());
		cobolAlphabeticTypeEClass.getESuperTypes().add(this.getCOBOLSimpleType());
		cobolObjectReferenceTypeEClass.getESuperTypes().add(this.getCOBOLSimpleType());
		cobolUnicodeTypeEClass.getESuperTypes().add(this.getCOBOLSimpleType());
		cobolInternalFloatTypeEClass.getESuperTypes().add(this.getCOBOLSimpleType());
		cobolExternalFloatTypeEClass.getESuperTypes().add(this.getCOBOLSimpleType());
		cobolAddressingTypeEClass.getESuperTypes().add(this.getCOBOLSimpleType());
		cobolElementInitialValueEClass.getESuperTypes().add(theTDLangPackage.getTDLangElement());

		// Initialize classes and features; add operations and parameters
		initEClass(cobolSimpleTypeEClass, COBOLSimpleType.class, "COBOLSimpleType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOLSimpleType_Usage(), this.getCOBOLUsageValues(), "usage", null, 0, 1, COBOLSimpleType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLSimpleType_PictureString(), ecorePackage.getEString(), "pictureString", null, 0, 1, COBOLSimpleType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLSimpleType_Synchronized(), ecorePackage.getEBooleanObject(), "synchronized", "false", 0, 1, COBOLSimpleType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cobolElementEClass, COBOLElement.class, "COBOLElement", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOLElement_Level(), ecorePackage.getEString(), "level", null, 0, 1, COBOLElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLElement_Redefined(), ecorePackage.getEBooleanObject(), "redefined", "false", 0, 1, COBOLElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLElement_IsFiller(), ecorePackage.getEBooleanObject(), "isFiller", "false", 0, 1, COBOLElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLElement_IsExternal(), ecorePackage.getEBooleanObject(), "isExternal", "false", 0, 1, COBOLElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLElement_IsGlobal(), ecorePackage.getEBooleanObject(), "isGlobal", "false", 0, 1, COBOLElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCOBOLElement_Contains(), this.getCOBOL88Element(), null, "contains", null, 0, -1, COBOLElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCOBOLElement_SharedType(), this.getCOBOLClassifier(), this.getCOBOLClassifier_TypedElement(), "sharedType", null, 1, 1, COBOLElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCOBOLElement_Array(), this.getCOBOLFixedLengthArray(), null, "array", null, 0, 1, COBOLElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCOBOLElement_Group(), this.getCOBOLComposedType(), this.getCOBOLComposedType_Element(), "group", null, 0, 1, COBOLElement.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCOBOLElement_Source(), this.getCOBOLSourceText(), null, "source", null, 1, 1, COBOLElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCOBOLElement_Initial(), this.getCOBOLElementInitialValue(), null, "initial", null, 0, -1, COBOLElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cobolVariableLengthArrayEClass, COBOLVariableLengthArray.class, "COBOLVariableLengthArray", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOLVariableLengthArray_MinUpper(), ecorePackage.getEInt(), "minUpper", null, 0, 1, COBOLVariableLengthArray.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCOBOLVariableLengthArray_DependingOn(), this.getCOBOLElement(), null, "dependingOn", null, 1, 1, COBOLVariableLengthArray.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cobolRedefiningElementEClass, COBOLRedefiningElement.class, "COBOLRedefiningElement", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCOBOLRedefiningElement_Redefines(), this.getCOBOLElement(), null, "redefines", null, 1, 1, COBOLRedefiningElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cobolComposedTypeEClass, COBOLComposedType.class, "COBOLComposedType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCOBOLComposedType_Element(), this.getCOBOLElement(), this.getCOBOLElement_Group(), "element", null, 0, -1, COBOLComposedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(coboL88ElementEClass, COBOL88Element.class, "COBOL88Element", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOL88Element_Name(), ecorePackage.getEString(), "name", null, 0, 1, COBOL88Element.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCOBOL88Element_Has(), this.getCOBOL88ElementValue(), null, "has", null, 1, -1, COBOL88Element.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(coboL88ElementValueEClass, COBOL88ElementValue.class, "COBOL88ElementValue", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOL88ElementValue_LowerLimit(), ecorePackage.getEString(), "lowerLimit", null, 0, 1, COBOL88ElementValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOL88ElementValue_UpperLimit(), ecorePackage.getEString(), "upperLimit", null, 0, 1, COBOL88ElementValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOL88ElementValue_Range(), ecorePackage.getEBooleanObject(), "range", null, 0, 1, COBOL88ElementValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cobolAlphaNumericTypeEClass, COBOLAlphaNumericType.class, "COBOLAlphaNumericType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOLAlphaNumericType_JustifyRight(), ecorePackage.getEBooleanObject(), "justifyRight", "false", 0, 1, COBOLAlphaNumericType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cobolNumericEditedTypeEClass, COBOLNumericEditedType.class, "COBOLNumericEditedType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOLNumericEditedType_BlankWhenZero(), ecorePackage.getEBooleanObject(), "blankWhenZero", "false", 0, 1, COBOLNumericEditedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLNumericEditedType_CurrencySymbol(), ecorePackage.getEString(), "currencySymbol", null, 0, 1, COBOLNumericEditedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLNumericEditedType_CurrencySign(), ecorePackage.getEString(), "currencySign", null, 0, 1, COBOLNumericEditedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLNumericEditedType_Decimal(), ecorePackage.getEBooleanObject(), "decimal", null, 0, 1, COBOLNumericEditedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cobolNumericTypeEClass, COBOLNumericType.class, "COBOLNumericType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOLNumericType_Signed(), ecorePackage.getEBooleanObject(), "signed", "true", 0, 1, COBOLNumericType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLNumericType_SignLeading(), ecorePackage.getEBooleanObject(), "signLeading", "false", 0, 1, COBOLNumericType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLNumericType_SignSeparate(), ecorePackage.getEBooleanObject(), "signSeparate", "false", 0, 1, COBOLNumericType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLNumericType_Trunc(), this.getCOBOLTruncValue(), "trunc", null, 0, 1, COBOLNumericType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLNumericType_Numproc(), this.getCOBOLNumprocValue(), "numproc", null, 0, 1, COBOLNumericType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLNumericType_Precision(), ecorePackage.getEInt(), "precision", null, 0, 1, COBOLNumericType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLNumericType_Scale(), ecorePackage.getEInt(), "scale", null, 0, 1, COBOLNumericType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(coboL66ElementEClass, COBOL66Element.class, "COBOL66Element", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOL66Element_Name(), ecorePackage.getEString(), "name", null, 0, 1, COBOL66Element.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCOBOL66Element_Start(), this.getCOBOLElement(), null, "start", null, 1, 1, COBOL66Element.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCOBOL66Element_EndOf(), this.getCOBOLElement(), null, "endOf", null, 0, 1, COBOL66Element.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cobolFixedLengthArrayEClass, COBOLFixedLengthArray.class, "COBOLFixedLengthArray", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOLFixedLengthArray_MaxUpper(), ecorePackage.getEInt(), "maxUpper", null, 0, 1, COBOLFixedLengthArray.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(coboldbcsTypeEClass, COBOLDBCSType.class, "COBOLDBCSType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOLDBCSType_JustifyRight(), ecorePackage.getEBooleanObject(), "justifyRight", "false", 0, 1, COBOLDBCSType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cobolAlphaNumericEditedTypeEClass, COBOLAlphaNumericEditedType.class, "COBOLAlphaNumericEditedType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(cobolClassifierEClass, COBOLClassifier.class, "COBOLClassifier", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOLClassifier_Typedef(), ecorePackage.getEBooleanObject(), "typedef", null, 0, 1, COBOLClassifier.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCOBOLClassifier_TypedElement(), this.getCOBOLElement(), this.getCOBOLElement_SharedType(), "typedElement", null, 0, -1, COBOLClassifier.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cobolAlphabeticTypeEClass, COBOLAlphabeticType.class, "COBOLAlphabeticType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOLAlphabeticType_JustifyRight(), ecorePackage.getEBooleanObject(), "justifyRight", "false", 0, 1, COBOLAlphabeticType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cobolObjectReferenceTypeEClass, COBOLObjectReferenceType.class, "COBOLObjectReferenceType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOLObjectReferenceType_ClassName(), ecorePackage.getEString(), "className", null, 0, 1, COBOLObjectReferenceType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cobolSourceTextEClass, COBOLSourceText.class, "COBOLSourceText", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOLSourceText_Source(), ecorePackage.getEString(), "source", null, 0, 1, COBOLSourceText.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLSourceText_FileName(), ecorePackage.getEString(), "fileName", null, 0, 1, COBOLSourceText.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cobolUnicodeTypeEClass, COBOLUnicodeType.class, "COBOLUnicodeType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(cobolInternalFloatTypeEClass, COBOLInternalFloatType.class, "COBOLInternalFloatType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(cobolExternalFloatTypeEClass, COBOLExternalFloatType.class, "COBOLExternalFloatType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(cobolAddressingTypeEClass, COBOLAddressingType.class, "COBOLAddressingType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(cobolElementInitialValueEClass, COBOLElementInitialValue.class, "COBOLElementInitialValue", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCOBOLElementInitialValue_InitVal(), ecorePackage.getEString(), "initVal", null, 0, 1, COBOLElementInitialValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCOBOLElementInitialValue_ValueKind(), this.getCOBOLInitialValueKind(), "valueKind", "string_value", 0, 1, COBOLElementInitialValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(cobolUsageValuesEEnum, COBOLUsageValues.class, "COBOLUsageValues");
		addEEnumLiteral(cobolUsageValuesEEnum, COBOLUsageValues.BINARY_LITERAL);
		addEEnumLiteral(cobolUsageValuesEEnum, COBOLUsageValues.DBCS_LITERAL);
		addEEnumLiteral(cobolUsageValuesEEnum, COBOLUsageValues.DOUBLE_LITERAL);
		addEEnumLiteral(cobolUsageValuesEEnum, COBOLUsageValues.DISPLAY_LITERAL);
		addEEnumLiteral(cobolUsageValuesEEnum, COBOLUsageValues.FLOAT_LITERAL);
		addEEnumLiteral(cobolUsageValuesEEnum, COBOLUsageValues.INDEX_LITERAL);
		addEEnumLiteral(cobolUsageValuesEEnum, COBOLUsageValues.NATIONAL_LITERAL);
		addEEnumLiteral(cobolUsageValuesEEnum, COBOLUsageValues.OBJECT_REFERENCE_LITERAL);
		addEEnumLiteral(cobolUsageValuesEEnum, COBOLUsageValues.PACKED_DECIMAL_LITERAL);
		addEEnumLiteral(cobolUsageValuesEEnum, COBOLUsageValues.POINTER_LITERAL);
		addEEnumLiteral(cobolUsageValuesEEnum, COBOLUsageValues.PROCEDURE_POINTER_LITERAL);
		addEEnumLiteral(cobolUsageValuesEEnum, COBOLUsageValues.FUNCTION_POINTER_LITERAL);

		initEEnum(cobolInitialValueKindEEnum, COBOLInitialValueKind.class, "COBOLInitialValueKind");
		addEEnumLiteral(cobolInitialValueKindEEnum, COBOLInitialValueKind.STRING_VALUE_LITERAL);
		addEEnumLiteral(cobolInitialValueKindEEnum, COBOLInitialValueKind.LOW_VALUE_LITERAL);
		addEEnumLiteral(cobolInitialValueKindEEnum, COBOLInitialValueKind.HIGH_VALUE_LITERAL);
		addEEnumLiteral(cobolInitialValueKindEEnum, COBOLInitialValueKind.ZERO_VALUE_LITERAL);
		addEEnumLiteral(cobolInitialValueKindEEnum, COBOLInitialValueKind.QUOTES_LITERAL);
		addEEnumLiteral(cobolInitialValueKindEEnum, COBOLInitialValueKind.NULL_LITERAL);
		addEEnumLiteral(cobolInitialValueKindEEnum, COBOLInitialValueKind.ALL_LITERAL_LITERAL);
		addEEnumLiteral(cobolInitialValueKindEEnum, COBOLInitialValueKind.SPACES_LITERAL);

		initEEnum(cobolTruncValueEEnum, COBOLTruncValue.class, "COBOLTruncValue");
		addEEnumLiteral(cobolTruncValueEEnum, COBOLTruncValue.STD_LITERAL);
		addEEnumLiteral(cobolTruncValueEEnum, COBOLTruncValue.OPT_LITERAL);
		addEEnumLiteral(cobolTruncValueEEnum, COBOLTruncValue.BIN_LITERAL);

		initEEnum(cobolNumprocValueEEnum, COBOLNumprocValue.class, "COBOLNumprocValue");
		addEEnumLiteral(cobolNumprocValueEEnum, COBOLNumprocValue.NOPFD_LITERAL);
		addEEnumLiteral(cobolNumprocValueEEnum, COBOLNumprocValue.PFD_LITERAL);
		addEEnumLiteral(cobolNumprocValueEEnum, COBOLNumprocValue.MIG_LITERAL);

		// Create resource
		createResource(eNS_URI);
	}

} //COBOLPackageImpl
